stages:
  - build
  - deploy

build:
  image: node:alpine
  stage: build
  script:
    - yarn install
    - yarn lint
    - yarn build
    - date > dist/version.txt
    - echo $CI_COMMIT_SHA >> dist/version.txt
    - echo $CI_COMMIT_TITLE >> dist/version.txt
  artifacts:
    expire_in: 1 week
    paths:
      - dist
  cache:
    paths:
      - node_modules/

deploy:
  image: alpine
  stage: deploy
  only:
    - master
  script:
    - apk add --no-cache rsync openssh
    - mkdir -p ~/.ssh
    - echo "$SSH_PRIVATE_KEY" >> ~/.ssh/id_dsa
    - chmod 600 ~/.ssh/id_dsa
    - echo -e "Host *\n\tStrictHostKeyChecking no\n\n" > ~/.ssh/config
    - rsync -avz --delete ./dist/ "$DEPLOY_USER@$DEPLOY_HOST:$DEPLOY_DIR"
    - ssh "$DEPLOY_USER@$DEPLOY_HOST" "$DEPLOY_RESTART_APP_COMMAND"
